/* zcpqli.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

real zcpqli_c(integer *nn, real *pt, real *q)
{
    /* Initialized data */

    static real zero = 0.f;
    static real pt1 = .1f;
    static real ptoo5 = .005f;

    /* System generated locals */
    integer i__1;
    real ret_val, r__1;

    /* Builtin functions */
    double log(doublereal), exp(doublereal);

    /* Local variables */
    static real f;
    static integer i__, n;
    static real x, df, dx, xm;

    /* Parameter adjustments */
    --q;
    --pt;

    /* Function Body */
    pt[(0 + (0 + (*nn << 2))) / 4] = -pt[(0 + (0 + (*nn << 2))) / 4];
    n = *nn - 1;
    x = (real)exp((real)(((real)log((real)(-pt[*nn])) - (real)log(pt[1])) /
            (real) n));
    if (pt[n] == zero) {
        goto L1;
    }
    xm = -pt[*nn] / pt[n];
    if (xm < x) {
        x = xm;
    }
L1:
    xm = x * pt1;
    f = pt[1];
    i__1 = *nn;
    for (i__ = 2; i__ <= i__1; ++i__) {
        f = f * xm + pt[i__];
/* L2: */
    }
    if (f <= zero) {
        goto L3;
    }
    x = xm;
    goto L1;
L3:
    dx = x;
L4:
    if ((r__1 = dx / x, abs(r__1)) <= ptoo5) {
        goto L7;
    }
    q[1] = pt[1];
    i__1 = *nn;
    for (i__ = 2; i__ <= i__1; ++i__) {
        q[i__] = q[i__ - 1] * x + pt[i__];
/* L5: */
    }
    f = q[*nn];
    df = q[1];
    i__1 = n;
    for (i__ = 2; i__ <= i__1; ++i__) {
        df = df * x + q[i__];
/* L6: */
    }
    dx = f / df;
    x -= dx;
    goto L4;
L7:
    ret_val = x;
    return ret_val;
} /* zcpqli_c */
