/* zcpqlj.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

real zcpqlj_c(integer *nn, real *pt, real *repsr1, real *rinfp, real *repsp,
        real *radix)
{
    /* Initialized data */

    static real zero = 0.f;
    static real half = .5f;
    static real one = 1.f;

    /* System generated locals */
    integer i__1;
    real ret_val;

    /* Builtin functions */
    double sqrt(doublereal), log(doublereal), pow_ri(real *, integer *);

    /* Local variables */
    static real rmin, rmax;
    static integer i__, l;
    static real x, sc, rhi, rlo;

    /* Parameter adjustments */
    --pt;

    /* Function Body */
    rhi = (real)sqrt(*rinfp);
    rlo = *repsp / *repsr1;
    rmax = zero;
    rmin = *rinfp;
    i__1 = *nn;
    for (i__ = 1; i__ <= i__1; ++i__) {
        x = pt[i__];
        if (x > rmax) {
            rmax = x;
        }
        if (x != zero && x < rmin) {
            rmin = x;
        }
/* L5: */
    }
    ret_val = one;
    if (rmin >= rlo && rmax <= rhi) {
        goto L9005;
    }
    x = rlo / rmin;
    if (x > one) {
        goto L10;
    }
    sc = one / ((real)sqrt(rmax) * (real)sqrt(rmin));
    goto L15;
L10:
    sc = x;
    if (*rinfp / sc < rmax) {
        sc = one;
    }
L15:
    l = (real)log(sc) / (real)log(*radix) + half;
    ret_val = (real)pow_ri(radix, &l);
L9005:
    return ret_val;
} /* zcpqlj_c */
